import es

import __init__ as sh

info = sh.info

def load():
    if not es.exists('command', 'sh_holdindexprop'):
        es.regcmd('sh_holdindexprop', '%s/holdcmd'%info.basename, 'Holds index prop at specified value for x seconds')
        es.regcmd('sh_linearindexprop', '%s/linearcmd'%info.basename, 'Alters index prop value linearly')
        es.regcmd('sh_linearcmd', '%s/linearcmdcmd'%info.basename, 'Alters value for a command linearly')

def holdcmd():
    if es.getargc() < 5:
        es.dbgmsg(0, 'Syntax: sh_holdindexprop <entity index> <property> <value> <time>')
        es.dbgmsg(0, 'Holds the property value for specified number of seconds')
        return False
    index = int(es.getargv(1))
    prop = str(es.getargv(2))
    value = es.getargv(3)
    secs = float(es.getargv(4))
    sh.holdindexprop(index,prop,value,secs)
    return True


def linearcmd():
    if es.getargc() < 6:
        es.dbgmsg(0, 'Syntax: sh_linearindexprop <entity index> <property> <start value> <end value> <time>')
        es.dbgmsg(0, 'Slides the property value linearly from start to end')
        return False
    index = int(es.getargv(1))
    prop = str(es.getargv(2))
    value1 = es.getargv(3)
    value2 = es.getargv(4)
    secs = float(es.getargv(5))
    sh.linearindexprop(index,prop,value1,value2,secs)
    return True


def linearcmdcmd():
    if es.getargc() < 5:
        es.dbgmsg(0, 'Syntax: sh_linearcmd <start value> <end value> <time> <command> [parameters]')
        es.dbgmsg(0, 'Slides the value linearly from start to end and calls command')
        es.dbgmsg(0, 'If parameters for command are included, you can use %% to denote')
        es.dbgmsg(0, 'where the changing value should be inserted (defaults to be last parameter)')
        return False
    args = sh.getargs()
    value1 = args[1]
    value2 = args[2]
    secs = float(args[3])
    comm = str(args[4])
    pre_args = args[5:]
    if '%%' not in pre_args:
        pre_args.append('%%')
    post_args = ()
    sh.linearcommand(value1,value2,secs, comm, tuple(pre_args), tuple(post_args))
    return True
